/*
 * Vifir - An electronic flight bag wannabe utility for aircraft pilots
 * Copyright (C) 2009 David Ludlow
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * dave@adsllc.com, PO Box 13070, Toledo, OH 43623
 */

#ifndef IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_
#define IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_

#include <time.h>
#include <gtkmm/dialog.h>
#include <gtkmm/combobox.h>
#include <gtkmm/label.h>
#include <gtkmm/liststore.h>
#include <libglademm.h>
#include <string>

class ImportSectionalsDVDVolumeChooserDialog
{
public:
	ImportSectionalsDVDVolumeChooserDialog(std::string *GladeFilename, std::string DataPath);
	~ImportSectionalsDVDVolumeChooserDialog();

	int Run();
	void GetData(std::string *Volume, time_t *EffectiveFrom, time_t *EffectiveTo);

private:
	class VolumeComboModelColumns : public Gtk::TreeModel::ColumnRecord {
	public:

		VolumeComboModelColumns() { add(Volume); add(EffectiveFrom); }

		Gtk::TreeModelColumn<std::string> Volume;
		Gtk::TreeModelColumn<time_t> EffectiveFrom;
	};

	void on_VolumeComboBox_changed();
	void PopulateVolumeComboBox();
	bool ParseMetaDate(std::string Line, time_t *Date);

	std::string DataPath;
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::ComboBox *VolumeComboBox;
	Gtk::Label *EffectiveFromLabel;
	Gtk::Label *EffectiveToLabel;

	std::string Volume;
	time_t EffectiveFrom;
	static const unsigned int EffectiveDuration=28*24*60*60;

	VolumeComboModelColumns VolumeComboColumns;
	Glib::RefPtr<Gtk::ListStore> VolumeComborefTreeModel;
};

#endif /*IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_*/
