/*
 * Vifir - An electronic flight bag wannabe utility for aircraft pilots
 * Copyright (C) 2009 David Ludlow
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * dave@adsllc.com, PO Box 13070, Toledo, OH 43623
 */

#ifndef IMPORTSHAPEFILE_H_
#define IMPORTSHAPEFILE_H_

#include <gtkmm/window.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/button.h>
#include <libglademm.h>
#include "Config.h"
#include "Shapefile.h"

class ImportShapefile
{
public:
	ImportShapefile(Config *Cfg, std::string *GladeFilename, Shapefile *ShapefileData);
	~ImportShapefile();

	int Run();
	void on_CancelButton_clicked();
	void ScheduleMainLoop();

private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Config *Cfg;
	std::string *GladeFilename;
	Gtk::Window *ProgressWindow;
	Gtk::ProgressBar *ProgressBar,*SubProgressBar;
	Gtk::Button *CancelButton;
	bool CancelFlag;
	Shapefile *ShapefileData;
};

#endif /*IMPORTSHAPEFILE_H_*/
